]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
urlmatch: include host in urlmatch ranking
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
1c244f6e 37files=
06b1abb5 38remote=
31ca3ac3 39nofetch=
32948425 40update=
15fc56a8 41prefix=
73b0898d 42custom_name=
275cd184 43depth=
72c5f883 44progress=
70c7ac22 45
be9d0a3a
HV
46die_if_unmatched ()
47{
48 if test "$1" = "#unmatched"
49 then
c4c02bf1 50 exit ${2:-1}
be9d0a3a
HV
51 fi
52}
53
88ce00c3
TK
54#
55# Print a submodule configuration setting
56#
57# $1 = submodule name
58# $2 = option name
59# $3 = default value
60#
61# Checks in the usual git-config places first (for overrides),
62# otherwise it falls back on .gitmodules. This allows you to
63# distribute project-wide defaults in .gitmodules, while still
64# customizing individual repositories if necessary. If the option is
65# not in .gitmodules either, print a default value.
66#
67get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
75 fi
76 printf '%s' "${value:-$default}"
77}
78
862ae6cd
RS
79isnumber()
80{
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
82}
83
14111fc4
JK
84# Sanitize the local git environment for use within a submodule. We
85# can't simply use clear_local_git_env since we want to preserve some
86# of the settings from GIT_CONFIG_PARAMETERS.
87sanitize_submodule_env()
88{
89044baa 89 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 90 clear_local_git_env
89044baa 91 GIT_CONFIG_PARAMETERS=$save_config
860cba61 92 export GIT_CONFIG_PARAMETERS
14111fc4
JK
93}
94
ecda0723
SV
95#
96# Add a new submodule to the working tree, .gitmodules and the index
97#
ec05df35 98# $@ = repo path
ecda0723
SV
99#
100# optional branch is stored in global branch variable
101#
23a485e3 102cmd_add()
ecda0723 103{
5c08dbbd 104 # parse $args after "submodule ... add".
091a6eb0 105 reference_path=
5c08dbbd
JH
106 while test $# -ne 0
107 do
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
113 ;;
d27b876b
JL
114 -f | --force)
115 force=$1
116 ;;
5c08dbbd 117 -q|--quiet)
2e6a30ef 118 GIT_QUIET=1
5c08dbbd 119 ;;
d92a3959
MT
120 --reference)
121 case "$2" in '') usage ;; esac
091a6eb0 122 reference_path=$2
d92a3959
MT
123 shift
124 ;;
125 --reference=*)
091a6eb0 126 reference_path="${1#--reference=}"
d92a3959 127 ;;
73b0898d
JL
128 --name)
129 case "$2" in '') usage ;; esac
130 custom_name=$2
131 shift
132 ;;
275cd184
FG
133 --depth)
134 case "$2" in '') usage ;; esac
135 depth="--depth=$2"
136 shift
137 ;;
138 --depth=*)
139 depth=$1
140 ;;
5c08dbbd
JH
141 --)
142 shift
143 break
144 ;;
145 -*)
146 usage
147 ;;
148 *)
149 break
150 ;;
151 esac
152 shift
153 done
154
091a6eb0
JK
155 if test -n "$reference_path"
156 then
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
159
160 reference="--reference=$reference_path"
161 fi
162
ecda0723 163 repo=$1
64394e3a 164 sm_path=$2
ecda0723 165
64394e3a 166 if test -z "$sm_path"; then
6a066230 167 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
169 fi
170
496eeeb1 171 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
172 usage
173 fi
174
091a6eb0
JK
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
176
ec05df35
ML
177 # assure repo is absolute or relative to parent
178 case "$repo" in
179 ./*|../*)
091a6eb0
JK
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
182
ec05df35 183 # dereference source url relative to parent's url
63e95beb 184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
185 ;;
186 *:*|/*)
187 # absolute url
188 realrepo=$repo
189 ;;
190 *)
497ee872 191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
192 ;;
193 esac
194
db75ada5
MG
195 # normalize path:
196 # multiple //; leading ./; /./; /../; trailing /
64394e3a 197 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
198 sed -e '
199 s|//*|/|g
200 s|^\(\./\)*||
8196e728 201 s|/\(\./\)*|/|g
db75ada5
MG
202 :start
203 s|\([^/]*\)/\.\./||
204 tstart
205 s|/*$||
206 ')
64394e3a
RJ
207 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
208 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 209
64394e3a 210 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 211 then
6ff875c5 212 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 213\$sm_path
6ff875c5 214Use -f if you really want to add it." >&2
d27b876b
JL
215 exit 1
216 fi
217
73b0898d
JL
218 if test -n "$custom_name"
219 then
220 sm_name="$custom_name"
221 else
222 sm_name="$sm_path"
223 fi
224
d4264ca3 225 # perhaps the path exists and is already a git repo, else clone it
64394e3a 226 if test -e "$sm_path"
d4264ca3 227 then
496eeeb1 228 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 229 then
64394e3a 230 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 231 else
64394e3a 232 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 233 fi
c2f93917 234
d4264ca3 235 else
4b7c286e
JL
236 if test -d ".git/modules/$sm_name"
237 then
238 if test -z "$force"
239 then
0d71dbfd 240 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 241 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
242 die "$(eval_gettextln "\
243If you want to reuse this local git directory instead of cloning again from
244 \$realrepo
245use the '--force' option. If the local git directory is not the correct repo
246or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 247 else
0d71dbfd 248 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
249 fi
250 fi
d10e3b42 251 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 252 (
14111fc4 253 sanitize_submodule_env
d851ffb9
JH
254 cd "$sm_path" &&
255 # ash fails to wordsplit ${branch:+-b "$branch"...}
256 case "$branch" in
257 '') git checkout -f -q ;;
258 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
259 esac
260 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 261 fi
73b0898d 262 git config submodule."$sm_name".url "$realrepo"
d4264ca3 263
64394e3a
RJ
264 git add $force "$sm_path" ||
265 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 266
73b0898d
JL
267 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
268 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
269 if test -n "$branch"
270 then
271 git config -f .gitmodules submodule."$sm_name".branch "$branch"
272 fi &&
31991b02 273 git add --force .gitmodules ||
64394e3a 274 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
275}
276
19a31f9c
ML
277#
278# Execute an arbitrary command sequence in each checked out
279# submodule
280#
281# $@ = command to execute
282#
283cmd_foreach()
284{
1d5bec8b
JH
285 # parse $args after "submodule ... foreach".
286 while test $# -ne 0
287 do
288 case "$1" in
289 -q|--quiet)
290 GIT_QUIET=1
291 ;;
15fc56a8
JH
292 --recursive)
293 recursive=1
294 ;;
1d5bec8b
JH
295 -*)
296 usage
297 ;;
298 *)
299 break
300 ;;
301 esac
302 shift
303 done
304
f030c96d
ÆAB
305 toplevel=$(pwd)
306
4dca1aa6
BC
307 # dup stdin so that it can be restored when running the external
308 # command in the subshell (and a recursive call to this function)
309 exec 3<&0
310
b0f4b408
SB
311 {
312 git submodule--helper list --prefix "$wt_prefix" ||
c4c02bf1 313 echo "#unmatched" $?
b0f4b408 314 } |
64394e3a 315 while read mode sha1 stage sm_path
19a31f9c 316 do
c4c02bf1 317 die_if_unmatched "$mode" "$sha1"
64394e3a 318 if test -e "$sm_path"/.git
19a31f9c 319 then
44431df0 320 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
ea2fa104 321 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 322 name=$(git submodule--helper name "$sm_path")
15fc56a8 323 (
64394e3a 324 prefix="$prefix$sm_path/"
14111fc4 325 sanitize_submodule_env
64394e3a 326 cd "$sm_path" &&
44431df0 327 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
091a6eb0
JK
328 # we make $path available to scripts ...
329 path=$sm_path &&
1c4fb136
AK
330 if test $# -eq 1
331 then
332 eval "$1"
333 else
334 "$@"
335 fi &&
15fc56a8
JH
336 if test -n "$recursive"
337 then
338 cmd_foreach "--recursive" "$@"
339 fi
4dca1aa6 340 ) <&3 3<&- ||
ea2fa104 341 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
342 fi
343 done
344}
345
70c7ac22 346#
211b7f19 347# Register submodules in .git/config
70c7ac22
LH
348#
349# $@ = requested paths (default to all)
350#
23a485e3 351cmd_init()
70c7ac22 352{
5c08dbbd
JH
353 # parse $args after "submodule ... init".
354 while test $# -ne 0
355 do
356 case "$1" in
357 -q|--quiet)
2e6a30ef 358 GIT_QUIET=1
5c08dbbd
JH
359 ;;
360 --)
361 shift
362 break
363 ;;
364 -*)
365 usage
366 ;;
367 *)
368 break
369 ;;
370 esac
371 shift
372 done
373
6e7c14e6 374 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
375}
376
cf419828
JL
377#
378# Unregister submodules from .git/config and remove their work tree
379#
cf419828
JL
380cmd_deinit()
381{
382 # parse $args after "submodule ... deinit".
f6a52799 383 deinit_all=
cf419828
JL
384 while test $# -ne 0
385 do
386 case "$1" in
387 -f|--force)
388 force=$1
389 ;;
390 -q|--quiet)
391 GIT_QUIET=1
392 ;;
f6a52799
SB
393 --all)
394 deinit_all=t
395 ;;
cf419828
JL
396 --)
397 shift
398 break
399 ;;
400 -*)
401 usage
402 ;;
403 *)
404 break
405 ;;
406 esac
407 shift
408 done
409
f6a52799
SB
410 if test -n "$deinit_all" && test "$#" -ne 0
411 then
412 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
413 usage
414 fi
415 if test $# = 0 && test -z "$deinit_all"
cf419828 416 then
f6a52799 417 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
cf419828
JL
418 fi
419
b0f4b408
SB
420 {
421 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 422 echo "#unmatched" $?
b0f4b408 423 } |
cf419828
JL
424 while read mode sha1 stage sm_path
425 do
c4c02bf1 426 die_if_unmatched "$mode" "$sha1"
0ea306ef 427 name=$(git submodule--helper name "$sm_path") || exit
cf419828 428
44431df0 429 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
091a6eb0 430
cf419828
JL
431 # Remove the submodule work tree (unless the user already did it)
432 if test -d "$sm_path"
433 then
434 # Protect submodules containing a .git directory
435 if test -d "$sm_path/.git"
436 then
0d71dbfd
VA
437 die "$(eval_gettext "\
438Submodule work tree '\$displaypath' contains a .git directory
439(use 'rm -rf' if you really want to remove it including all of its history)")"
cf419828
JL
440 fi
441
442 if test -z "$force"
443 then
7b294bf4 444 git rm -qn "$sm_path" ||
091a6eb0 445 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 446 fi
7b294bf4 447 rm -rf "$sm_path" &&
091a6eb0
JK
448 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
449 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
450 fi
451
091a6eb0 452 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
453
454 # Remove the .git/config entries (unless the user already did it)
455 if test -n "$(git config --get-regexp submodule."$name\.")"
456 then
457 # Remove the whole section so we have a clean state when
458 # the user later decides to init this submodule again
459 url=$(git config submodule."$name".url)
460 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 461 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
462 fi
463 done
464}
465
fb43e31f 466is_tip_reachable () (
01e1d544 467 sanitize_submodule_env &&
fb43e31f
SB
468 cd "$1" &&
469 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
470 test -z "$rev"
471)
472
473fetch_in_submodule () (
01e1d544 474 sanitize_submodule_env &&
fb43e31f
SB
475 cd "$1" &&
476 case "$2" in
477 '')
478 git fetch ;;
479 *)
6cbf454a
SB
480 shift
481 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
482 esac
483)
484
70c7ac22 485#
211b7f19 486# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
487#
488# $@ = requested paths (default to all)
489#
23a485e3 490cmd_update()
70c7ac22 491{
5c08dbbd
JH
492 # parse $args after "submodule ... update".
493 while test $# -ne 0
494 do
495 case "$1" in
496 -q|--quiet)
2e6a30ef 497 GIT_QUIET=1
5c08dbbd 498 ;;
72c5f883
JK
499 --progress)
500 progress="--progress"
501 ;;
be4d2c83 502 -i|--init)
d92a3959 503 init=1
be4d2c83 504 ;;
06b1abb5
TK
505 --remote)
506 remote=1
507 ;;
31ca3ac3 508 -N|--no-fetch)
31ca3ac3
FF
509 nofetch=1
510 ;;
9db31bdf
NMC
511 -f|--force)
512 force=$1
513 ;;
ca2cedba 514 -r|--rebase)
32948425 515 update="rebase"
ca2cedba 516 ;;
d92a3959
MT
517 --reference)
518 case "$2" in '') usage ;; esac
519 reference="--reference=$2"
98dbe63d 520 shift
d92a3959
MT
521 ;;
522 --reference=*)
523 reference="$1"
d92a3959 524 ;;
42b49178 525 -m|--merge)
42b49178
JH
526 update="merge"
527 ;;
b13fd5c1 528 --recursive)
b13fd5c1
JH
529 recursive=1
530 ;;
efc5fb6a
JH
531 --checkout)
532 update="checkout"
533 ;;
abed000a
SB
534 --recommend-shallow)
535 recommend_shallow="--recommend-shallow"
536 ;;
537 --no-recommend-shallow)
538 recommend_shallow="--no-recommend-shallow"
539 ;;
275cd184
FG
540 --depth)
541 case "$2" in '') usage ;; esac
542 depth="--depth=$2"
543 shift
544 ;;
545 --depth=*)
546 depth=$1
547 ;;
2335b870
SB
548 -j|--jobs)
549 case "$2" in '') usage ;; esac
550 jobs="--jobs=$2"
551 shift
552 ;;
553 --jobs=*)
554 jobs=$1
555 ;;
5c08dbbd
JH
556 --)
557 shift
558 break
559 ;;
560 -*)
561 usage
562 ;;
563 *)
564 break
565 ;;
566 esac
98dbe63d 567 shift
5c08dbbd
JH
568 done
569
d92a3959
MT
570 if test -n "$init"
571 then
572 cmd_init "--" "$@" || return
573 fi
574
48308681
SB
575 {
576 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
72c5f883 577 ${progress:+"$progress"} \
48308681
SB
578 ${wt_prefix:+--prefix "$wt_prefix"} \
579 ${prefix:+--recursive-prefix "$prefix"} \
580 ${update:+--update "$update"} \
5f50f33e 581 ${reference:+"$reference"} \
48308681 582 ${depth:+--depth "$depth"} \
abed000a 583 ${recommend_shallow:+"$recommend_shallow"} \
2335b870 584 ${jobs:+$jobs} \
c4c02bf1 585 "$@" || echo "#unmatched" $?
48308681 586 } | {
15ffb7cd 587 err=
48308681 588 while read mode sha1 stage just_cloned sm_path
70c7ac22 589 do
c4c02bf1 590 die_if_unmatched "$mode" "$sha1"
48308681 591
0ea306ef 592 name=$(git submodule--helper name "$sm_path") || exit
5be60078 593 url=$(git config submodule."$name".url)
efc5fb6a
JH
594 if ! test -z "$update"
595 then
596 update_module=$update
597 else
598 update_module=$(git config submodule."$name".update)
a2aed08b
TK
599 if test -z "$update_module"
600 then
601 update_module="checkout"
602 fi
efc5fb6a
JH
603 fi
604
44431df0 605 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 606
48308681 607 if test $just_cloned -eq 1
d851ffb9 608 then
bf2d8246 609 subsha1=
48308681 610 update_module=checkout
bf2d8246 611 else
14111fc4 612 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 613 git rev-parse --verify HEAD) ||
091a6eb0 614 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 615 fi
211b7f19 616
06b1abb5
TK
617 if test -n "$remote"
618 then
92bbe7cc 619 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
620 if test -z "$nofetch"
621 then
622 # Fetch remote before determining tracking $sha1
6cbf454a 623 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
624 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
625 fi
14111fc4
JK
626 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
627 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 628 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 629 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
630 fi
631
496eeeb1 632 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 633 then
9db31bdf
NMC
634 subforce=$force
635 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 636 if test -z "$subsha1" && test -z "$force"
b9b378a0 637 then
9db31bdf 638 subforce="-f"
b9b378a0 639 fi
31ca3ac3
FF
640
641 if test -z "$nofetch"
642 then
e5f522d6
JL
643 # Run fetch only if $sha1 isn't present or it
644 # is not reachable from a ref.
fb43e31f 645 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 646 fetch_in_submodule "$sm_path" $depth ||
091a6eb0 647 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
648
649 # Now we tried the usual fetch, but $sha1 may
650 # not be reachable from any of the refs
651 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 652 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 653 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
654 fi
655
877449c1 656 must_die_on_failure=
32948425 657 case "$update_module" in
a2aed08b
TK
658 checkout)
659 command="git checkout $subforce -q"
660 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
661 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
662 ;;
32948425
JH
663 rebase)
664 command="git rebase"
091a6eb0
JK
665 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
666 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 667 must_die_on_failure=yes
32948425 668 ;;
42b49178
JH
669 merge)
670 command="git merge"
091a6eb0
JK
671 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
672 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 673 must_die_on_failure=yes
42b49178 674 ;;
6cb5728c
CP
675 !*)
676 command="${update_module#!}"
b08238ac
SB
677 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
678 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
679 must_die_on_failure=yes
680 ;;
32948425 681 *)
a2aed08b 682 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 683 esac
70c7ac22 684
14111fc4 685 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 686 then
ff968f03 687 say "$say_msg"
877449c1
JH
688 elif test -n "$must_die_on_failure"
689 then
ff968f03 690 die_with_status 2 "$die_msg"
15ffb7cd 691 else
ff968f03 692 err="${err};$die_msg"
877449c1 693 continue
15ffb7cd 694 fi
70c7ac22 695 fi
b13fd5c1
JH
696
697 if test -n "$recursive"
698 then
75bf5e60 699 (
44431df0 700 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 701 wt_prefix=
14111fc4 702 sanitize_submodule_env
75bf5e60 703 cd "$sm_path" &&
36141282 704 eval cmd_update
75bf5e60 705 )
15ffb7cd
FG
706 res=$?
707 if test $res -gt 0
708 then
091a6eb0 709 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 710 if test $res -ne 2
15ffb7cd 711 then
ff968f03 712 err="${err};$die_msg"
15ffb7cd
FG
713 continue
714 else
ff968f03 715 die_with_status $res "$die_msg"
15ffb7cd
FG
716 fi
717 fi
b13fd5c1 718 fi
70c7ac22 719 done
15ffb7cd
FG
720
721 if test -n "$err"
722 then
723 OIFS=$IFS
724 IFS=';'
725 for e in $err
726 do
727 if test -n "$e"
728 then
729 echo >&2 "$e"
730 fi
731 done
732 IFS=$OIFS
733 exit 1
734 fi
735 }
70c7ac22
LH
736}
737
bffe71f4
EM
738set_name_rev () {
739 revname=$( (
14111fc4 740 sanitize_submodule_env
bffe71f4 741 cd "$1" && {
5be60078
JH
742 git describe "$2" 2>/dev/null ||
743 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
744 git describe --contains "$2" 2>/dev/null ||
745 git describe --all --always "$2"
bffe71f4
EM
746 }
747 ) )
748 test -z "$revname" || revname=" ($revname)"
749}
28f9af5d
PY
750#
751# Show commit summary for submodules in index or working tree
752#
753# If '--cached' is given, show summary between index and given commit,
754# or between working tree and given commit
755#
756# $@ = [commit (default 'HEAD'),] requested paths (default all)
757#
758cmd_summary() {
f2dc06a3 759 summary_limit=-1
d0f64dd4 760 for_status=
1c244f6e 761 diff_cmd=diff-index
f2dc06a3 762
28f9af5d
PY
763 # parse $args after "submodule ... summary".
764 while test $# -ne 0
765 do
766 case "$1" in
767 --cached)
768 cached="$1"
769 ;;
1c244f6e
JL
770 --files)
771 files="$1"
772 ;;
d0f64dd4
PY
773 --for-status)
774 for_status="$1"
775 ;;
f2dc06a3 776 -n|--summary-limit)
862ae6cd
RS
777 summary_limit="$2"
778 isnumber "$summary_limit" || usage
f2dc06a3
PY
779 shift
780 ;;
862ae6cd
RS
781 --summary-limit=*)
782 summary_limit="${1#--summary-limit=}"
783 isnumber "$summary_limit" || usage
784 ;;
28f9af5d
PY
785 --)
786 shift
787 break
788 ;;
789 -*)
790 usage
791 ;;
792 *)
793 break
794 ;;
795 esac
796 shift
797 done
bffe71f4 798
f2dc06a3
PY
799 test $summary_limit = 0 && return
800
3deea89c 801 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
802 then
803 head=$rev
caa9c3ca 804 test $# = 0 || shift
496eeeb1 805 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 806 then
14e940d7
JH
807 # before the first commit: compare with an empty tree
808 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 809 test -z "$1" || shift
28f9af5d 810 else
3deea89c 811 head="HEAD"
28f9af5d
PY
812 fi
813
1c244f6e
JL
814 if [ -n "$files" ]
815 then
816 test -n "$cached" &&
465d6a00 817 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
818 diff_cmd=diff-files
819 head=
820 fi
821
28f9af5d 822 cd_to_toplevel
091a6eb0 823 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 824 # Get modified modules cared by user
18076502 825 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 826 sane_egrep '^:([0-7]* )?160000' |
2be94509 827 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
828 do
829 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
830 if test "$status" = D || test "$status" = T
831 then
6a066230 832 printf '%s\n' "$sm_path"
496eeeb1
EP
833 continue
834 fi
927b26f8 835 # Respect the ignore setting for --for-status.
836 if test -n "$for_status"
837 then
0ea306ef 838 name=$(git submodule--helper name "$sm_path")
927b26f8 839 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 840 test $status != A && test $ignore_config = all && continue
927b26f8 841 fi
28f9af5d 842 # Also show added or modified modules which are checked out
2be94509 843 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 844 printf '%s\n' "$sm_path"
28f9af5d
PY
845 done
846 )
1cb639e6 847
d0f64dd4
PY
848 test -z "$modules" && return
849
18076502 850 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 851 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
852 cut -c2- |
853 while read mod_src mod_dst sha1_src sha1_dst status name
854 do
855 if test -z "$cached" &&
856 test $sha1_dst = 0000000000000000000000000000000000000000
857 then
858 case "$mod_dst" in
859 160000)
860 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
861 ;;
862 100644 | 100755 | 120000)
863 sha1_dst=$(git hash-object $name)
864 ;;
865 000000)
866 ;; # removed
867 *)
868 # unexpected type
6ff875c5 869 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
870 continue ;;
871 esac
872 fi
873 missing_src=
874 missing_dst=
875
876 test $mod_src = 160000 &&
30353a40 877 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
878 missing_src=t
879
880 test $mod_dst = 160000 &&
30353a40 881 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 882 missing_dst=t
bffe71f4 883
44431df0 884 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 885
1cb639e6
PY
886 total_commits=
887 case "$missing_src,$missing_dst" in
888 t,)
091a6eb0 889 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
890 ;;
891 ,t)
091a6eb0 892 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
893 ;;
894 t,t)
091a6eb0 895 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
896 ;;
897 *)
898 errmsg=
899 total_commits=$(
496eeeb1 900 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
901 then
902 range="$sha1_src...$sha1_dst"
903 elif test $mod_src = 160000
904 then
905 range=$sha1_src
906 else
907 range=$sha1_dst
908 fi
909 GIT_DIR="$name/.git" \
b0e621ad 910 git rev-list --first-parent $range -- | wc -l
1cb639e6 911 )
eed35595 912 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
913 ;;
914 esac
915
916 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
917 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
918 if test $status = T
919 then
b3e73449
ÆAB
920 blob="$(gettext "blob")"
921 submodule="$(gettext "submodule")"
1cb639e6
PY
922 if test $mod_dst = 160000
923 then
091a6eb0 924 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 925 else
091a6eb0 926 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
927 fi
928 else
091a6eb0 929 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
930 fi
931 if test -n "$errmsg"
932 then
933 # Don't give error msg for modification whose dst is not submodule
934 # i.e. deleted or changed to blob
935 test $mod_dst = 160000 && echo "$errmsg"
936 else
496eeeb1 937 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 938 then
f2dc06a3
PY
939 limit=
940 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 941 GIT_DIR="$name/.git" \
f2dc06a3 942 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
943 --first-parent $sha1_src...$sha1_dst
944 elif test $mod_dst = 160000
945 then
946 GIT_DIR="$name/.git" \
947 git log --pretty='format: > %s' -1 $sha1_dst
948 else
949 GIT_DIR="$name/.git" \
950 git log --pretty='format: < %s' -1 $sha1_src
951 fi
952 echo
953 fi
954 echo
3ba7407b 955 done
28f9af5d 956}
70c7ac22 957#
941987a5 958# List all submodules, prefixed with:
70c7ac22
LH
959# - submodule not initialized
960# + different revision checked out
961#
962# If --cached was specified the revision in the index will be printed
963# instead of the currently checked out revision.
964#
965# $@ = requested paths (default to all)
966#
23a485e3 967cmd_status()
70c7ac22 968{
5c08dbbd
JH
969 # parse $args after "submodule ... status".
970 while test $# -ne 0
971 do
972 case "$1" in
973 -q|--quiet)
2e6a30ef 974 GIT_QUIET=1
5c08dbbd
JH
975 ;;
976 --cached)
977 cached=1
978 ;;
64b19ffe
JH
979 --recursive)
980 recursive=1
981 ;;
5c08dbbd
JH
982 --)
983 shift
984 break
985 ;;
986 -*)
987 usage
988 ;;
989 *)
990 break
991 ;;
992 esac
993 shift
994 done
995
b0f4b408
SB
996 {
997 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 998 echo "#unmatched" $?
b0f4b408 999 } |
64394e3a 1000 while read mode sha1 stage sm_path
70c7ac22 1001 do
c4c02bf1 1002 die_if_unmatched "$mode" "$sha1"
0ea306ef 1003 name=$(git submodule--helper name "$sm_path") || exit
5be60078 1004 url=$(git config submodule."$name".url)
44431df0 1005 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
313ee0d6
NMC
1006 if test "$stage" = U
1007 then
1008 say "U$sha1 $displaypath"
1009 continue
1010 fi
496eeeb1
EP
1011 if test -z "$url" ||
1012 {
1013 ! test -d "$sm_path"/.git &&
1014 ! test -f "$sm_path"/.git
1015 }
70c7ac22 1016 then
64b19ffe 1017 say "-$sha1 $displaypath"
70c7ac22
LH
1018 continue;
1019 fi
64394e3a 1020 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1021 then
b545cd15 1022 set_name_rev "$sm_path" "$sha1"
64b19ffe 1023 say " $sha1 $displaypath$revname"
70c7ac22
LH
1024 else
1025 if test -z "$cached"
1026 then
14111fc4 1027 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1028 fi
b545cd15 1029 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1030 say "+$sha1 $displaypath$revname"
1031 fi
1032
1033 if test -n "$recursive"
1034 then
1035 (
1036 prefix="$displaypath/"
14111fc4 1037 sanitize_submodule_env
10450cf7 1038 wt_prefix=
64394e3a 1039 cd "$sm_path" &&
e15bec0e 1040 eval cmd_status
64b19ffe 1041 ) ||
64394e3a 1042 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1043 fi
1044 done
1045}
2327f61e
DA
1046#
1047# Sync remote urls for submodules
1048# This makes the value for remote.$remote.url match the value
1049# specified in .gitmodules.
1050#
1051cmd_sync()
1052{
1053 while test $# -ne 0
1054 do
1055 case "$1" in
1056 -q|--quiet)
2e6a30ef 1057 GIT_QUIET=1
2327f61e
DA
1058 shift
1059 ;;
82f49f29
PH
1060 --recursive)
1061 recursive=1
1062 shift
1063 ;;
2327f61e
DA
1064 --)
1065 shift
1066 break
1067 ;;
1068 -*)
1069 usage
1070 ;;
1071 *)
1072 break
1073 ;;
1074 esac
1075 done
1076 cd_to_toplevel
b0f4b408
SB
1077 {
1078 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 1079 echo "#unmatched" $?
b0f4b408 1080 } |
64394e3a 1081 while read mode sha1 stage sm_path
2327f61e 1082 do
c4c02bf1 1083 die_if_unmatched "$mode" "$sha1"
0ea306ef 1084 name=$(git submodule--helper name "$sm_path")
2327f61e 1085 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1086
1087 # Possibly a url relative to parent
1088 case "$url" in
1089 ./*|../*)
967b2c66
JS
1090 # rewrite foo/bar as ../.. to find path from
1091 # submodule work tree to superproject work tree
6a066230 1092 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1093 # guarantee a trailing /
1094 up_path=${up_path%/}/ &&
1095 # path from submodule work tree to submodule origin repo
63e95beb 1096 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
967b2c66 1097 # path from superproject work tree to submodule origin repo
63e95beb 1098 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
967b2c66
JS
1099 ;;
1100 *)
1101 sub_origin_url="$url"
1102 super_config_url="$url"
baede9f8
JH
1103 ;;
1104 esac
1105
ccee6086 1106 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1107 then
44431df0 1108 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 1109 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1110 git config submodule."$name".url "$super_config_url"
ccee6086 1111
64394e3a 1112 if test -e "$sm_path"/.git
ccee6086
JH
1113 then
1114 (
14111fc4 1115 sanitize_submodule_env
64394e3a 1116 cd "$sm_path"
ccee6086 1117 remote=$(get_default_remote)
967b2c66 1118 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1119
1120 if test -n "$recursive"
1121 then
1122 prefix="$prefix$sm_path/"
1123 eval cmd_sync
1124 fi
ccee6086
JH
1125 )
1126 fi
2327f61e
DA
1127 fi
1128 done
1129}
70c7ac22 1130
f6f85861
SB
1131cmd_absorbgitdirs()
1132{
1133 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1134}
1135
5c08dbbd
JH
1136# This loop parses the command line arguments to find the
1137# subcommand name to dispatch. Parsing of the subcommand specific
1138# options are primarily done by the subcommand implementations.
1139# Subcommand specific options such as --branch and --cached are
1140# parsed here as well, for backward compatibility.
1141
1142while test $# != 0 && test -z "$command"
70c7ac22
LH
1143do
1144 case "$1" in
f6f85861 1145 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 1146 command=$1
70c7ac22
LH
1147 ;;
1148 -q|--quiet)
2e6a30ef 1149 GIT_QUIET=1
70c7ac22 1150 ;;
ecda0723
SV
1151 -b|--branch)
1152 case "$2" in
1153 '')
1154 usage
1155 ;;
1156 esac
1157 branch="$2"; shift
1158 ;;
70c7ac22 1159 --cached)
28f9af5d 1160 cached="$1"
70c7ac22
LH
1161 ;;
1162 --)
1163 break
1164 ;;
1165 -*)
1166 usage
1167 ;;
1168 *)
1169 break
1170 ;;
1171 esac
1172 shift
1173done
1174
5c08dbbd 1175# No command word defaults to "status"
af9c9f97
RR
1176if test -z "$command"
1177then
1178 if test $# = 0
1179 then
1180 command=status
1181 else
1182 usage
1183 fi
1184fi
5c08dbbd
JH
1185
1186# "-b branch" is accepted only by "add"
1187if test -n "$branch" && test "$command" != add
1188then
ecda0723 1189 usage
5c08dbbd
JH
1190fi
1191
28f9af5d 1192# "--cached" is accepted only by "status" and "summary"
496eeeb1 1193if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1194then
70c7ac22 1195 usage
5c08dbbd
JH
1196fi
1197
1198"cmd_$command" "$@"